///File : MainFrame.hpp
//------------------------------------------------------------------------------
/*
    This file is part of DevisMaker.

    DevisMaker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DevisMaker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DevisMaker.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#if not defined FRAME_ROOMS_ITEMS_EDIT_HPP_DEVIS_MAKER
#define FRAME_ROOMS_ITEMS_EDIT_HPP_DEVIS_MAKER

//------------------------------------------------------------------------------
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
//------------------------------------------------------------------------------
#include <wx/notebook.h>
#include <wx/html/helpctrl.h>
//------------------------------------------------------------------------------
#include <ItemSectionDBManager.hpp>
//------------------------------------------------------------------------------
#include "MainPanel.hpp"
#include "DialogAbout.hpp"
#include "strWxStdConv.hpp"
//------------------------------------------------------------------------------
class MainPanel;
class MainFrame;
//------------------------------------------------------------------------------
class MainFrame : public wxFrame
{
public:
    MainFrame(const wxString& title, const wxPoint& pos, const wxSize& size, long style = wxDEFAULT_FRAME_STYLE);
    ~MainFrame();
    void OnFrameClose(wxCloseEvent& event);
    void OnAbout(wxCommandEvent& event);
    void OnQuit(wxCommandEvent& event);
    void OnSave(wxCommandEvent& event);
    void OnUndo(wxCommandEvent& event);
    void OnRedo(wxCommandEvent& event);
    void OnSelectAll(wxCommandEvent& event);
    void OnNotebookChange(wxCommandEvent& event);
    void OnHelp(wxCommandEvent& event);

    wxString GetBackupDescription(const int &pos);
    void MyRefreshMenu();
    bool AskToSave();

    // Menu
    wxMenuItem* CreateImageMenuItem( wxMenu *parentMenu, wxString dataFilename, const int &id = wxID_ANY, const wxString &value = _T("")) const;

protected:
    wxNotebook *m_MainNotebook;
    MainPanel *m_PanelSections;
    MainPanel *m_PanelItems;

    wxString m_undoStr, m_undoKey;
    wxString m_redoStr, m_redoKey;

    wxMenuItem *m_ItemRedo, *m_ItemUndo, *m_ItemSelectAll;

    ItemSectionDBManager *m_IRDBManager;
};

#endif //FRAME_ROOMS_ITEMS_EDIT_HPP_DEVIS_MAKER
